<template>
  <RimowSelectize
    v-if="parameter.type === 'string+dataset-id'"
    placeholder="Select a dataset..."
    data-cy="dataset-dropdown"
    :add-properties="addProperties(parameter, HTMLSelectElement)"
    item-icon="database"
    :clearable="false"
    :selected="selected"
    :options="projectDatasets"
    :disabled="disabled"
    @change="updateDatasetSelectField"
  />
</template>

<script>
export default {
  props: {
    parameter: {
      type: Object,
      default: () => {},
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    addProperties: {
      type: Function,
      default: () => ({}),
    },
  },
  data() {
    return {
      projectId: this.$nuxt.$route.params.id,
      scenarioId: this.$nuxt.$route.params.scenarioId,
      HTMLSelectElement: null,
    };
  },
  computed: {
    param() {
      return this.$nuxt.context.store.state.parameters.inputMap[
        this.parameter.key
      ];
    },
    projectDatasets() {
      return this.$nuxt.context.store.getters['projects/projectDatasets'](
        this.projectId
      );
    },
    selected() {
      if (this.param.value) {
        return this.projectDatasets.find((df) => {
          return df.id === this.param.value;
        });
      }
      return undefined;
    },
  },
  mounted() {
    this.HTMLSelectElement = HTMLSelectElement;
  },
  methods: {
    async updateDatasetSelectField(value) {
      if (this.disabled) return;
      await this.$nuxt.context.store.dispatch('datasets/fetchSingleDataset', {
        datasetId: value.id,
      });
      await this.$nuxt.context.store.dispatch(
        'parameters/updateDatasetSelect',
        {
          projectId: this.projectId,
          scenarioId: this.scenarioId,
          key: this.parameter.key,
          newSelected: value,
        }
      );
    },
  },
};
</script>
